CREATE DATABASE IF NOT EXISTS brasilprev;

CREATE TABLE IF NOT EXISTS public.cliente
(
    id uuid NOT NULL,
    cpf character varying(255) COLLATE pg_catalog."default",
    data_de_nascimento date,
    email character varying(255) COLLATE pg_catalog."default",
    genero integer,
    nome character varying(255) COLLATE pg_catalog."default",
    renda_mensal numeric(19,2),
    CONSTRAINT cliente_pkey PRIMARY KEY (id)
);

CREATE TABLE IF NOT EXISTS public.plano
(
    id uuid NOT NULL,
    aporte numeric(19,2),
    data_da_contratacao date,
    id_cliente uuid,
    id_produto uuid,
    idade_de_aposentadoria integer,
    CONSTRAINT plano_pkey PRIMARY KEY (id)
);

CREATE TABLE IF NOT EXISTS public.produto
(
    id uuid NOT NULL,
    carencia_entre_resgates integer,
    carencia_inicial_de_resgate integer,
    expiracao_de_venda timestamp without time zone,
    idade_de_entrada integer,
    idade_de_saida integer,
    nome character varying(255) COLLATE pg_catalog."default",
    susep character varying(255) COLLATE pg_catalog."default",
    valor_minimo_aporte_extra numeric(19,2),
    valor_minimo_aporte_inicial numeric(19,2),
    CONSTRAINT produto_pkey PRIMARY KEY (id)
);