package br.com.rodrigosieja.brasilprev.handler;

import br.com.rodrigosieja.brasilprev.exception.CancelledPlanException;
import br.com.rodrigosieja.brasilprev.exception.CustomerNotFoundException;
import br.com.rodrigosieja.brasilprev.exception.ExpiredSalesDeadlineException;
import br.com.rodrigosieja.brasilprev.exception.InvalidAdditionalIntakeException;
import br.com.rodrigosieja.brasilprev.exception.InvalidAgeException;
import br.com.rodrigosieja.brasilprev.exception.InvalidInitialIntakeException;
import br.com.rodrigosieja.brasilprev.exception.InvalidRedemptionException;
import br.com.rodrigosieja.brasilprev.exception.PlanNotFoundException;
import br.com.rodrigosieja.brasilprev.exception.ProductNotFoundException;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.ControllerAdvice;
import org.springframework.web.bind.annotation.ExceptionHandler;

@ControllerAdvice
public class GlobalExceptionHandler {

    @ExceptionHandler({InvalidInitialIntakeException.class})
    public ResponseEntity<Object> handleInvalidInitialIntakeException(InvalidInitialIntakeException exception) {
        return ResponseEntity
                .status(HttpStatus.BAD_REQUEST)
                .body(exception.getMessage());
    }

    @ExceptionHandler({InvalidAdditionalIntakeException.class})
    public ResponseEntity<Object> handleInvalidAdditionalIntakeException(InvalidInitialIntakeException exception) {
        return ResponseEntity
                .status(HttpStatus.BAD_REQUEST)
                .body(exception.getMessage());
    }

    @ExceptionHandler({InvalidAgeException.class})
    public ResponseEntity<Object> handleInvalidAgeException(InvalidAgeException exception) {
        return ResponseEntity
                .status(HttpStatus.BAD_REQUEST)
                .body(exception.getMessage());
    }

    @ExceptionHandler({InvalidRedemptionException.class})
    public ResponseEntity<Object> handleInvalidRedemptionException(InvalidRedemptionException exception) {
        return ResponseEntity
                .status(HttpStatus.BAD_REQUEST)
                .body(exception.getMessage());
    }

    @ExceptionHandler({CancelledPlanException.class})
    public ResponseEntity<Object> handleCancelledPlanException(CancelledPlanException exception) {
        return ResponseEntity
                .status(HttpStatus.BAD_REQUEST)
                .body(exception.getMessage());
    }

    @ExceptionHandler({ExpiredSalesDeadlineException.class})
    public ResponseEntity<Object> handleExpiredSalesDeadlineException(ExpiredSalesDeadlineException exception) {
        return ResponseEntity
                .status(HttpStatus.BAD_REQUEST)
                .body(exception.getMessage());
    }

    @ExceptionHandler({CustomerNotFoundException.class})
    public ResponseEntity<Object> handleCustomerNotFoundException(CustomerNotFoundException exception) {
        return ResponseEntity
                .status(HttpStatus.NOT_FOUND)
                .body(exception.getMessage());
    }

    @ExceptionHandler({PlanNotFoundException.class})
    public ResponseEntity<Object> handlePlanNotFoundException(PlanNotFoundException exception) {
        return ResponseEntity
                .status(HttpStatus.NOT_FOUND)
                .body(exception.getMessage());
    }

    @ExceptionHandler({ProductNotFoundException.class})
    public ResponseEntity<Object> handleProductNotFoundException(ProductNotFoundException exception) {
        return ResponseEntity
                .status(HttpStatus.NOT_FOUND)
                .body(exception.getMessage());
    }

}
