package br.com.rodrigosieja.brasilprev.model.dto;

import io.swagger.v3.oas.annotations.media.Schema;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.UUID;

@Schema(name = "DTO de Aporte Extra")
public class AporteExtraDTO implements Serializable {

    private static final long serialVersionUID = 3172452723290909861L;
    @Schema(
            description = "ID do cliente",
            name = "idCliente",
            type = "uuid",
            example = "77a819c5-bb2f-4ade-84a2-a81dfc67428b"
    )
    private UUID idCliente;

    @Schema(
            description = "ID do plano",
            name = "idPlano",
            type = "uuid",
            example = "24fb6c42-6234-402e-ac84-2306d8c16137"
    )
    private UUID idPlano;

    @Schema(
            description = "Valor do aporte",
            name = "valorAporte",
            type = "number",
            example = "100.0"
    )
    private BigDecimal valorAporte;

    public AporteExtraDTO() {
    }

    public AporteExtraDTO(UUID idCliente, UUID idPlano, BigDecimal valorAporte) {
        this.idCliente = idCliente;
        this.idPlano = idPlano;
        this.valorAporte = valorAporte;
    }

    public UUID getIdCliente() {
        return idCliente;
    }

    public void setIdCliente(UUID idCliente) {
        this.idCliente = idCliente;
    }

    public UUID getIdPlano() {
        return idPlano;
    }

    public void setIdPlano(UUID idPlano) {
        this.idPlano = idPlano;
    }

    public BigDecimal getValorAporte() {
        return valorAporte;
    }

    public void setValorAporte(BigDecimal valorAporte) {
        this.valorAporte = valorAporte;
    }

    @Override
    public String toString() {
        return "AporteExtraDTO{" +
                "idCliente=" + idCliente.toString() +
                ", idPlano=" + idPlano.toString() +
                ", valorAporte=" + valorAporte.doubleValue() +
                '}';
    }
}
