package br.com.rodrigosieja.brasilprev.model.dto;

import io.swagger.v3.oas.annotations.media.Schema;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.UUID;

@Schema(name = "DTO de Resgate")
public class ResgateDTO implements Serializable {

    private static final long serialVersionUID = -8804027028025555938L;

    @Schema(
            description = "ID do plano",
            name = "idPlano",
            type = "uuid",
            example = "24fb6c42-6234-402e-ac84-2306d8c16137"
    )
    private UUID idPlano;

    @Schema(
            description = "Valor do resgate",
            name = "valorResgate",
            type = "number",
            example = "100.0"
    )
    private BigDecimal valorResgate;

    public ResgateDTO() {
    }

    public ResgateDTO(UUID idPlano, BigDecimal valorResgate) {
        this.idPlano = idPlano;
        this.valorResgate = valorResgate;
    }

    public UUID getIdPlano() {
        return idPlano;
    }

    public void setIdPlano(UUID idPlano) {
        this.idPlano = idPlano;
    }

    public BigDecimal getValorResgate() {
        return valorResgate;
    }

    public void setValorResgate(BigDecimal valorResgate) {
        this.valorResgate = valorResgate;
    }

    @Override
    public String toString() {
        return "Resgate{" +
                "idPlano=" + idPlano.toString() +
                ", valorResgate=" + valorResgate.doubleValue() +
                '}';
    }

}
