package br.com.rodrigosieja.brasilprev.service;

import br.com.rodrigosieja.brasilprev.model.Plano;
import br.com.rodrigosieja.brasilprev.model.dto.AporteExtraDTO;
import br.com.rodrigosieja.brasilprev.repository.PlanoRepository;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.util.Optional;

@Service
public class AporteExtraService {

    private final PlanoRepository planoRepository;

    public AporteExtraService(PlanoRepository planoRepository) { this.planoRepository = planoRepository; }

    public Plano aporteExtra(final AporteExtraDTO aporteExtra) {
        Optional<Plano> planoEncontrado = planoRepository.findById(aporteExtra.getIdPlano());

        if (planoEncontrado.isPresent()) {
            Plano plano = planoEncontrado.get();

            BigDecimal aporteAnterior = plano.getAporte();

            BigDecimal aporteNovo = aporteAnterior.add(aporteExtra.getValorAporte());
            plano.setAporte(aporteNovo);

            return planoRepository.save(plano);
        }

        return null;
    }

    public boolean valorMinimoAporteProduto(final BigDecimal valorAporte,
                                            final BigDecimal valorMinimoAporteExtra) {
        return valorAporte.doubleValue() >=  valorMinimoAporteExtra.doubleValue();
    }

}
