package br.com.rodrigosieja.brasilprev.service;

import br.com.rodrigosieja.brasilprev.exception.CustomerNotFoundException;
import br.com.rodrigosieja.brasilprev.model.Cliente;
import br.com.rodrigosieja.brasilprev.repository.ClienteRepository;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Optional;
import java.util.UUID;

@Service
public class ClienteService {

    private final ClienteRepository clienteRepository;

    public ClienteService(ClienteRepository clienteRepository) {
        this.clienteRepository = clienteRepository;
    }

    public Cliente insere(final Cliente cliente) {
        return clienteRepository.save(cliente);
    }

    public Cliente busca(final UUID id) {
        Optional<Cliente> clienteEncontrado = clienteRepository.findById(id);
        return clienteEncontrado
                .orElseThrow(() -> new CustomerNotFoundException("Cliente não encontrado!"));
    }

    public List<Cliente> lista() {
        return clienteRepository.findAll();
    }

}
