package br.com.rodrigosieja.brasilprev.service;

import br.com.rodrigosieja.brasilprev.exception.ProductNotFoundException;
import br.com.rodrigosieja.brasilprev.model.Produto;
import br.com.rodrigosieja.brasilprev.repository.ProdutoRepository;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Optional;
import java.util.UUID;

@Service
public class ProdutoService {

    private final ProdutoRepository produtoRepository;

    public ProdutoService(ProdutoRepository produtoRepository) {
        this.produtoRepository = produtoRepository;
    }

    public Produto insere(final Produto produto) {
        return produtoRepository.save(produto);
    }

    public Produto busca(final UUID id) {
        Optional<Produto> produtoEncontrado = produtoRepository.findById(id);
        return produtoEncontrado
                .orElseThrow(() -> new ProductNotFoundException("Produto não encontrado!"));
    }

    public List<Produto> lista() {
        return produtoRepository.findAll();
    }
}
